Index: LMDZ6/trunk/libf/phylmd/ecrad/radiation_thermodynamics.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/ecrad/radiation_thermodynamics.F90	(revision 4488)
+++ LMDZ6/trunk/libf/phylmd/ecrad/radiation_thermodynamics.F90	(revision 4489)
@@ -297,5 +297,5 @@
 
     use yomhook,          only : lhook, dr_hook
-    use radiation_config, only : out_of_bounds_2d
+    use radiation_check,  only : out_of_bounds_2d
 
     class(thermodynamics_type), intent(inout) :: this
Index: LMDZ6/trunk/libf/phylmd/ecrad/radiation_tripleclouds_lw.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/ecrad/radiation_tripleclouds_lw.F90	(revision 4488)
+++ LMDZ6/trunk/libf/phylmd/ecrad/radiation_tripleclouds_lw.F90	(revision 4489)
@@ -18,4 +18,6 @@
 !   2017-10-23  R. Hogan  Renamed single-character variables
 !   2018-10-08  R. Hogan  Call calc_region_properties
+!   2020-09-18  R. Hogan  Replaced some array expressions with loops
+!   2020-09-19  R. Hogan  Implement the cloud-only-scattering optimization
 
 module radiation_tripleclouds_lw
@@ -28,4 +30,5 @@
 #include "radiation_optical_depth_scaling.h"
 
+  !---------------------------------------------------------------------
   ! This module contains just one subroutine, the longwave
   ! "Tripleclouds" solver in which cloud inhomogeneity is treated by
@@ -33,5 +36,4 @@
   ! cloudy (with differing optical depth). This approach was described
   ! by Shonk and Hogan (2008).
-
   subroutine solver_tripleclouds_lw(nlev,istartcol,iendcol, &
        &  config, cloud, & 
@@ -48,10 +50,10 @@
     use radiation_regions, only        : calc_region_properties
     use radiation_overlap, only        : calc_overlap_matrices
-    use radiation_flux, only           : flux_type, &
-         &                               indexed_sum, add_indexed_sum
+    use radiation_flux, only           : flux_type, indexed_sum
     use radiation_matrix, only         : singlemat_x_vec
     use radiation_two_stream, only     : calc_two_stream_gammas_lw, &
          &                               calc_reflectance_transmittance_lw, &
          &                               calc_no_scattering_transmittance_lw
+    use radiation_adding_ica_lw, only  : adding_ica_lw, calc_fluxes_no_scattering_lw
     use radiation_lw_derivatives, only : calc_lw_derivatives_region
 
@@ -130,9 +132,13 @@
     ! streams
     real(jprb), dimension(config%n_g_lw, nregions, nlev) &
-         &  :: Sup, Sdn
+         &  :: source_up, source_dn
+
+    ! Clear-sky reflectance and transmittance
+    real(jprb), dimension(config%n_g_lw, nlev) &
+         &  :: ref_clear, trans_clear
 
     ! ...clear-sky equivalent
     real(jprb), dimension(config%n_g_lw, nlev) &
-         &  :: Sup_clear, Sdn_clear
+         &  :: source_up_clear, source_dn_clear
 
     ! Total albedo of the atmosphere/surface just above a layer
@@ -147,7 +153,4 @@
     real(jprb), dimension(config%n_g_lw, nregions, nlev+1) :: total_source
 
-    ! ...equivalent values for clear-skies
-    real(jprb), dimension(config%n_g_lw, nlev+1) :: total_albedo_clear, total_source_clear
-
     ! Total albedo and source of the atmosphere just below a layer interface
     real(jprb), dimension(config%n_g_lw, nregions) &
@@ -160,5 +163,5 @@
 
     ! ...clear-sky equivalent (no distinction between "above/below")
-    real(jprb), dimension(config%n_g_lw) &
+    real(jprb), dimension(config%n_g_lw, nlev+1) &
          &  :: flux_dn_clear, flux_up_clear
 
@@ -170,4 +173,7 @@
     ! and below the ground, both treated as single-region clear skies
     logical :: is_clear_sky_layer(0:nlev+1)
+
+    ! Index of the highest cloudy layer
+    integer :: i_cloud_top
 
     integer :: jcol, jlev, jg, jreg, jreg2, ng
@@ -208,16 +214,96 @@
       ! cloud%crop_cloud_fraction has already been called
       is_clear_sky_layer = .true.
+      i_cloud_top = nlev+1
       do jlev = 1,nlev
         if (cloud%fraction(jcol,jlev) > 0.0_jprb) then
           is_clear_sky_layer(jlev) = .false.
+          ! Get index to the first cloudy layer from the top
+          if (i_cloud_top > jlev) then
+            i_cloud_top = jlev
+          end if
         end if
       end do
-
-      ! --------------------------------------------------------
-      ! Section 3: Loop over layers to compute reflectance and transmittance
+      if (config%do_lw_aerosol_scattering) then
+        ! This is actually the first layer in which we need to
+        ! consider scattering
+        i_cloud_top = 1
+      end if
+
+      ! --------------------------------------------------------
+      ! Section 3: Clear-sky calculation
+      ! --------------------------------------------------------
+
+      if (.not. config%do_lw_aerosol_scattering) then
+        ! No scattering in clear-sky flux calculation
+        do jlev = 1,nlev
+          ! Array-wise assignments
+          gamma1 = 0.0_jprb
+          gamma2 = 0.0_jprb
+          call calc_no_scattering_transmittance_lw(ng, od(:,jlev,jcol), &
+               &  planck_hl(:,jlev,jcol), planck_hl(:,jlev+1, jcol), &
+               &  trans_clear(:,jlev), source_up_clear(:,jlev), source_dn_clear(:,jlev))
+          ref_clear(:,jlev) = 0.0_jprb
+        end do
+        ! Simple down-then-up method to compute fluxes
+        call calc_fluxes_no_scattering_lw(ng, nlev, &
+             &  trans_clear, source_up_clear, source_dn_clear, &
+             &  emission(:,jcol), albedo(:,jcol), &
+             &  flux_up_clear, flux_dn_clear)
+      else
+        ! Scattering in clear-sky flux calculation
+        do jlev = 1,nlev
+          ! Array-wise assignments
+          gamma1 = 0.0_jprb
+          gamma2 = 0.0_jprb
+          call calc_two_stream_gammas_lw(ng, &
+               &  ssa(:,jlev,jcol), g(:,jlev,jcol), gamma1, gamma2)
+          call calc_reflectance_transmittance_lw(ng, &
+               &  od(:,jlev,jcol), gamma1, gamma2, &
+               &  planck_hl(:,jlev,jcol), planck_hl(:,jlev+1,jcol), &
+               &  ref_clear(:,jlev), trans_clear(:,jlev), &
+               &  source_up_clear(:,jlev), source_dn_clear(:,jlev))
+        end do
+        ! Use adding method to compute fluxes
+        call adding_ica_lw(ng, nlev, &
+             &  ref_clear, trans_clear, source_up_clear, source_dn_clear, &
+             &  emission(:,jcol), albedo(:,jcol), &
+             &  flux_up_clear, flux_dn_clear)
+      end if
+
+      if (config%do_clear) then
+        ! Sum over g-points to compute broadband fluxes
+        flux%lw_up_clear(jcol,:) = sum(flux_up_clear,1)
+        flux%lw_dn_clear(jcol,:) = sum(flux_dn_clear,1)
+        ! Store surface spectral downwelling fluxes
+        flux%lw_dn_surf_clear_g(:,jcol) = flux_dn_clear(:,nlev+1)
+        ! Save the spectral fluxes if required
+        if (config%do_save_spectral_flux) then
+          do jlev = 1,nlev+1
+            call indexed_sum(flux_up_clear(:,jlev), &
+                 &           config%i_spec_from_reordered_g_lw, &
+                 &           flux%lw_up_clear_band(:,jcol,jlev))
+            call indexed_sum(flux_dn_clear(:,jlev), &
+                 &           config%i_spec_from_reordered_g_lw, &
+                 &           flux%lw_dn_clear_band(:,jcol,jlev))
+          end do
+        end if
+      end if
+
+      ! --------------------------------------------------------
+      ! Section 4: Loop over cloudy layers to compute reflectance and transmittance
       ! --------------------------------------------------------
       ! In this section the reflectance, transmittance and sources
       ! are computed for each layer
-      do jlev = 1,nlev ! Start at top-of-atmosphere
+      
+      ! Firstly, ensure clear-sky transmittance is valid for whole
+      ! depth of the atmosphere, because even above cloud it is used
+      ! by the LW derivatives
+      transmittance(:,1,:) = trans_clear(:,:)
+      ! Dummy values in cloudy regions above cloud top
+      if (i_cloud_top > 0) then
+        transmittance(:,2:,1:min(i_cloud_top,nlev)) = 1.0_jprb
+      end if
+
+      do jlev = i_cloud_top,nlev ! Start at cloud top and work down
 
         ! Array-wise assignments
@@ -225,30 +311,17 @@
         gamma2 = 0.0_jprb
 
+        ! Copy over clear-sky properties
+        reflectance(:,1,jlev)    = ref_clear(:,jlev)
+        source_up(:,1,jlev)      = source_up_clear(:,jlev) ! Scaled later by region size
+        source_dn(:,1,jlev)      = source_dn_clear(:,jlev) ! Scaled later by region size
         nreg = nregions
         if (is_clear_sky_layer(jlev)) then
           nreg = 1
           reflectance(:,2:,jlev)   = 0.0_jprb
-          transmittance(:,2:,jlev)   = 0.0_jprb
-          Sup(:,2:,jlev) = 0.0_jprb
-          Sdn(:,2:,jlev) = 0.0_jprb
-        end if
-        do jreg = 1,nreg
-          if (jreg == 1) then
-            ! Clear-sky calculation
-            if (.not. config%do_lw_aerosol_scattering) then
-              call calc_no_scattering_transmittance_lw(ng, od(:,jlev,jcol), &
-                   &  planck_hl(:,jlev,jcol), planck_hl(:,jlev+1, jcol), &
-                   &  transmittance(:,1,jlev), Sup(:,1,jlev), Sdn(:,1,jlev))
-              reflectance(:,1,jlev) = 0.0_jprb
-            else
-              call calc_two_stream_gammas_lw(ng, &
-                   &  ssa(:,jlev,jcol), g(:,jlev,jcol), gamma1, gamma2)
-              call calc_reflectance_transmittance_lw(ng, &
-                   &  od(:,jlev,jcol), gamma1, gamma2, &
-                   &  planck_hl(:,jlev,jcol), planck_hl(:,jlev+1,jcol), &
-                   &  reflectance(:,1,jlev), transmittance(:,1,jlev), &
-                   &  Sup(:,1,jlev), Sdn(:,1,jlev))
-            end if
-          else
+          transmittance(:,2:,jlev) = 1.0_jprb
+          source_up(:,2:,jlev)     = 0.0_jprb
+          source_dn(:,2:,jlev)     = 0.0_jprb
+        else
+          do jreg = 2,nreg
             ! Cloudy sky
             ! Add scaled cloud optical depth to clear-sky value
@@ -291,5 +364,5 @@
                    &  planck_hl(:,jlev,jcol), planck_hl(:,jlev+1,jcol), &
                    &  reflectance(:,jreg,jlev), transmittance(:,jreg,jlev), &
-                   &  Sup(:,jreg,jlev), Sdn(:,jreg,jlev))
+                   &  source_up(:,jreg,jlev), source_dn(:,jreg,jlev))
             else
               ! No-scattering case: use simpler functions for
@@ -297,18 +370,12 @@
               call calc_no_scattering_transmittance_lw(ng, od_total, &
                    &  planck_hl(:,jlev,jcol), planck_hl(:,jlev+1, jcol), &
-                   &  transmittance(:,jreg,jlev), Sup(:,jreg,jlev), Sdn(:,jreg,jlev))
+                   &  transmittance(:,jreg,jlev), source_up(:,jreg,jlev), source_dn(:,jreg,jlev))
               reflectance(:,jreg,jlev) = 0.0_jprb
             end if
-          end if
-        end do
-
-        ! Copy over the clear-sky emission
-        Sup_clear(:,jlev) = Sup(:,1,jlev)
-        Sdn_clear(:,jlev) = Sdn(:,1,jlev)
-        if (.not. is_clear_sky_layer(jlev)) then
+          end do
           ! Emission is scaled by the size of each region
           do jreg = 1,nregions
-            Sup(:,jreg,jlev) = region_fracs(jreg,jlev,jcol) * Sup(:,jreg,jlev)
-            Sdn(:,jreg,jlev) = region_fracs(jreg,jlev,jcol) * Sdn(:,jreg,jlev)
+            source_up(:,jreg,jlev) = region_fracs(jreg,jlev,jcol) * source_up(:,jreg,jlev)
+            source_dn(:,jreg,jlev) = region_fracs(jreg,jlev,jcol) * source_dn(:,jreg,jlev)
           end do
         end if
@@ -317,5 +384,5 @@
 
       ! --------------------------------------------------------
-      ! Section 4: Compute total sources albedos
+      ! Section 5: Compute total sources and albedos at each half level
       ! --------------------------------------------------------
 
@@ -333,48 +400,26 @@
         end do
       end do
-      ! Equivalent surface values for computing clear-sky fluxes 
-      if (config%do_clear) then
-        do jg = 1,ng
-          total_source_clear(jg,nlev+1) = emission(jg,jcol)
-        end do
-        ! In the case of surface albedo there is no dependence on
-        ! cloud fraction so we can copy the all-sky value
-        total_albedo_clear(1:ng,nlev+1) = total_albedo(1:ng,1,nlev+1)
-      end if
 
       ! Work up from the surface computing the total albedo of the
       ! atmosphere and the total upwelling due to emission below each
       ! level below using the adding method
-      do jlev = nlev,1,-1
+      do jlev = nlev,i_cloud_top,-1
 
         total_albedo_below        = 0.0_jprb
 
-        if (config%do_clear) then
-          ! For clear-skies there is no need to consider "above" and
-          ! "below" quantities since with no cloud overlap to worry
-          ! about, these are the same
-          inv_denom(:,1) = 1.0_jprb &
-               &  / (1.0_jprb - total_albedo_clear(:,jlev+1)*reflectance(:,1,jlev))
-          total_albedo_clear(:,jlev) = reflectance(:,1,jlev) &
-               &  + transmittance(:,1,jlev)*transmittance(:,1,jlev)*total_albedo_clear(:,jlev+1) &
-               &  * inv_denom(:,1)
-          total_source_clear(:,jlev) = Sup_clear(:,jlev) &
-               &  + transmittance(:,1,jlev)*(total_source_clear(:,jlev+1) &
-               &  + total_albedo_clear(:,jlev+1)*Sdn_clear(:,jlev)) &
-               &  * inv_denom(:,1)
-        end if
-
         if (is_clear_sky_layer(jlev)) then
-          inv_denom(:,1) = 1.0_jprb &
-               &  / (1.0_jprb - total_albedo(:,1,jlev+1)*reflectance(:,1,jlev))
           total_albedo_below = 0.0_jprb
-          total_albedo_below(:,1) = reflectance(:,1,jlev) &
-               &  + transmittance(:,1,jlev)*transmittance(:,1,jlev)*total_albedo(:,1,jlev+1) &
-               &  * inv_denom(:,1)
           total_source_below = 0.0_jprb
-          total_source_below(:,1) = Sup(:,1,jlev) &
-               &  + transmittance(:,1,jlev)*(total_source(:,1,jlev+1) &
-               &  + total_albedo(:,1,jlev+1)*Sdn(:,1,jlev)) &
-               &  * inv_denom(:,1)
+          do jg = 1,ng
+            inv_denom(jg,1) = 1.0_jprb &
+                 &  / (1.0_jprb - total_albedo(jg,1,jlev+1)*reflectance(jg,1,jlev))
+            total_albedo_below(jg,1) = reflectance(jg,1,jlev) &
+                 &  + transmittance(jg,1,jlev)*transmittance(jg,1,jlev)*total_albedo(jg,1,jlev+1) &
+                 &  * inv_denom(jg,1)
+            total_source_below(jg,1) = source_up(jg,1,jlev) &
+                 &  + transmittance(jg,1,jlev)*(total_source(jg,1,jlev+1) &
+                 &  + total_albedo(jg,1,jlev+1)*source_dn(jg,1,jlev)) &
+                 &  * inv_denom(jg,1)
+          end do
         else
           inv_denom = 1.0_jprb / (1.0_jprb - total_albedo(:,:,jlev+1)*reflectance(:,:,jlev))
@@ -382,7 +427,7 @@
                &  + transmittance(:,:,jlev)*transmittance(:,:,jlev)*total_albedo(:,:,jlev+1) &
                &  * inv_denom
-          total_source_below = Sup(:,:,jlev) &
+          total_source_below = source_up(:,:,jlev) &
                &  + transmittance(:,:,jlev)*(total_source(:,:,jlev+1) &
-               &  + total_albedo(:,:,jlev+1)*Sdn(:,:,jlev)) &
+               &  + total_albedo(:,:,jlev+1)*source_dn(:,:,jlev)) &
                &  * inv_denom
         end if
@@ -415,57 +460,73 @@
 
       ! --------------------------------------------------------
-      ! Section 5: Compute fluxes
-      ! --------------------------------------------------------
-
-      ! Top-of-atmosphere fluxes into the regions of the top-most
-      ! layer, zero since we assume no diffuse downwelling
-      flux_dn = 0.0_jprb
-
-      if (config%do_clear) then
-        flux_dn_clear = 0.0_jprb
+      ! Section 6: Copy over downwelling fluxes above cloud top
+      ! --------------------------------------------------------
+      do jlev = 1,i_cloud_top
+        if (config%do_clear) then
+          ! Clear-sky fluxes have already been averaged: use these
+          flux%lw_dn(jcol,jlev) = flux%lw_dn_clear(jcol,jlev)
+          if (config%do_save_spectral_flux) then
+            flux%lw_dn_band(:,jcol,jlev) = flux%lw_dn_clear_band(:,jcol,jlev)
+          end if
+        else
+          flux%lw_dn(jcol,:) = sum(flux_dn_clear(:,jlev))
+          if (config%do_save_spectral_flux) then
+            call indexed_sum(flux_dn_clear(:,jlev), &
+                 &           config%i_spec_from_reordered_g_lw, &
+                 &           flux%lw_dn_band(:,jcol,jlev))
+          end if
+        end if
+      end do
+
+      ! --------------------------------------------------------
+      ! Section 7: Compute fluxes up to top-of-atmosphere
+      ! --------------------------------------------------------
+
+      ! Compute the fluxes just above the highest cloud
+      flux_up(:,1) = total_source(:,1,i_cloud_top) &
+           &  + total_albedo(:,1,i_cloud_top)*flux_dn_clear(:,i_cloud_top)
+      flux_up(:,2:) = 0.0_jprb
+      flux%lw_up(jcol,i_cloud_top) = sum(flux_up(:,1))
+      if (config%do_save_spectral_flux) then
+        call indexed_sum(flux_up(:,1), &
+             &           config%i_spec_from_reordered_g_lw, &
+             &           flux%lw_up_band(:,jcol,i_cloud_top))
       end if
-
-      ! Store the TOA broadband fluxes
-      flux%lw_up(jcol,1) = sum(total_source(:,:,1))
-      flux%lw_dn(jcol,1) = 0.0_jprb
-      if (config%do_clear) then
-        flux%lw_up_clear(jcol,1) = sum(total_source_clear(:,1))
-        flux%lw_dn_clear(jcol,1) = 0.0_jprb
-      end if
-
-      ! Save the spectral fluxes if required
-      if (config%do_save_spectral_flux) then
-        call indexed_sum(sum(total_source(:,:,1),2), &
-             &           config%i_spec_from_reordered_g_lw, &
-             &           flux%lw_up_band(:,jcol,1))
-        flux%lw_dn_band(:,jcol,1) = 0.0_jprb
-        if (config%do_clear) then
-          call indexed_sum(total_source_clear(:,1), &
+      do jlev = i_cloud_top-1,1,-1
+        flux_up(:,1) = trans_clear(:,jlev)*flux_up(:,1) + source_up_clear(:,jlev)
+        flux%lw_up(jcol,jlev) = sum(flux_up(:,1))
+        if (config%do_save_spectral_flux) then
+          call indexed_sum(flux_up(:,1), &
                &           config%i_spec_from_reordered_g_lw, &
-               &           flux%lw_up_clear_band(:,jcol,1))
-          flux%lw_dn_clear_band(:,jcol,1) = 0.0_jprb
-        end if
-      end if
+               &           flux%lw_up_band(:,jcol,jlev))
+        end if
+      end do
+
+      ! --------------------------------------------------------
+      ! Section 8: Compute fluxes down to surface
+      ! --------------------------------------------------------
+
+      ! Copy over downwelling spectral fluxes at top of first
+      ! scattering layer, using overlap matrix to translate to the
+      ! regions of the first layer of cloud
+      do jreg = 1,nregions
+        flux_dn(:,jreg)  = v_matrix(jreg,1,i_cloud_top,jcol)*flux_dn_clear(:,i_cloud_top)
+      end do
 
       ! Final loop back down through the atmosphere to compute fluxes
-      do jlev = 1,nlev
-        if (config%do_clear) then
-          flux_dn_clear = (transmittance(:,1,jlev)*flux_dn_clear &
-               &  + reflectance(:,1,jlev)*total_source_clear(:,jlev+1) + Sdn_clear(:,jlev) ) &
-               &  / (1.0_jprb - reflectance(:,1,jlev)*total_albedo_clear(:,jlev+1))
-          flux_up_clear = total_source_clear(:,jlev+1) &
-               &        + flux_dn_clear*total_albedo_clear(:,jlev+1)
-        end if
+      do jlev = i_cloud_top,nlev
 
         if (is_clear_sky_layer(jlev)) then
-          flux_dn(:,1) = (transmittance(:,1,jlev)*flux_dn(:,1) &
-               &       + reflectance(:,1,jlev)*total_source(:,1,jlev+1) + Sdn(:,1,jlev) ) &
-               &  / (1.0_jprb - reflectance(:,1,jlev)*total_albedo(:,1,jlev+1))
+          do jg = 1,ng
+            flux_dn(jg,1) = (transmittance(jg,1,jlev)*flux_dn(jg,1) &
+                 &  + reflectance(jg,1,jlev)*total_source(jg,1,jlev+1) + source_dn(jg,1,jlev) ) &
+                 &  / (1.0_jprb - reflectance(jg,1,jlev)*total_albedo(jg,1,jlev+1))
+            flux_up(jg,1) = total_source(jg,1,jlev+1) + flux_dn(jg,1)*total_albedo(jg,1,jlev+1)
+          end do
           flux_dn(:,2:)  = 0.0_jprb
-          flux_up(:,1) = total_source(:,1,jlev+1) + flux_dn(:,1)*total_albedo(:,1,jlev+1)
           flux_up(:,2:)  = 0.0_jprb
         else
           flux_dn = (transmittance(:,:,jlev)*flux_dn &
-               &     + reflectance(:,:,jlev)*total_source(:,:,jlev+1) + Sdn(:,:,jlev) ) &
+               &     + reflectance(:,:,jlev)*total_source(:,:,jlev+1) + source_dn(:,:,jlev) ) &
                &  / (1.0_jprb - reflectance(:,:,jlev)*total_albedo(:,:,jlev+1))
           flux_up = total_source(:,:,jlev+1) + flux_dn*total_albedo(:,:,jlev+1)
@@ -485,8 +546,4 @@
         flux%lw_up(jcol,jlev+1) = sum(sum(flux_up,1))
         flux%lw_dn(jcol,jlev+1) = sum(sum(flux_dn,1))
-        if (config%do_clear) then
-          flux%lw_up_clear(jcol,jlev+1) = sum(flux_up_clear)
-          flux%lw_dn_clear(jcol,jlev+1) = sum(flux_dn_clear)
-        end if
 
         ! Save the spectral fluxes if required
@@ -498,13 +555,5 @@
                &           config%i_spec_from_reordered_g_lw, &
                &           flux%lw_dn_band(:,jcol,jlev+1))
-          if (config%do_clear) then
-            call indexed_sum(flux_up_clear, &
-                 &           config%i_spec_from_reordered_g_lw, &
-                 &           flux%lw_up_clear_band(:,jcol,jlev+1))
-            call indexed_sum(flux_dn_clear, &
-                 &           config%i_spec_from_reordered_g_lw, &
-                 &           flux%lw_dn_clear_band(:,jcol,jlev+1))
-          end if
-        end if
+         end if
 
       end do ! Final loop over levels
@@ -513,7 +562,4 @@
       ! are at the surface
       flux%lw_dn_surf_g(:,jcol) = sum(flux_dn,2)
-      if (config%do_clear) then
-        flux%lw_dn_surf_clear_g(:,jcol) = flux_dn_clear
-      end if
 
       ! Compute the longwave derivatives needed by Hogan and Bozzo
Index: LMDZ6/trunk/libf/phylmd/ecrad/radiation_tripleclouds_sw.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/ecrad/radiation_tripleclouds_sw.F90	(revision 4488)
+++ LMDZ6/trunk/libf/phylmd/ecrad/radiation_tripleclouds_sw.F90	(revision 4489)
@@ -19,4 +19,5 @@
 !   2018-10-08  R. Hogan  Call calc_region_properties
 !   2019-01-02  R. Hogan  Fixed problem of do_save_spectral_flux .and. .not. do_sw_direct
+!   2020-09-18  R. Hogan  Replaced some array expressions with loops for speed
 
 module radiation_tripleclouds_sw
@@ -32,4 +33,5 @@
 #include "radiation_optical_depth_scaling.h"
 
+  !---------------------------------------------------------------------
   ! This module contains just one subroutine, the shortwave
   ! "Tripleclouds" solver in which cloud inhomogeneity is treated by
@@ -37,5 +39,4 @@
   ! cloudy (with differing optical depth). This approach was described
   ! by Shonk and Hogan (2008).
-
   subroutine solver_tripleclouds_sw(nlev,istartcol,iendcol, &
        &  config, single_level, cloud, & 
@@ -356,25 +357,29 @@
           ! "below" quantities since with no cloud overlap to worry
           ! about, these are the same
-          inv_denom(:,1) = 1.0_jprb &
-               &  / (1.0_jprb - total_albedo_clear(:,jlev+1)*reflectance(:,1,jlev))
-          total_albedo_clear(:,jlev) = reflectance(:,1,jlev) &
-               &  + transmittance(:,1,jlev) * transmittance(:,1,jlev) &
-               &  * total_albedo_clear(:,jlev+1) * inv_denom(:,1)
-          total_albedo_clear_direct(:,jlev) = ref_dir(:,1,jlev) &
-               &  + (trans_dir_dir(:,1,jlev)*total_albedo_clear_direct(:,jlev+1) &
-               &     +trans_dir_diff(:,1,jlev)*total_albedo_clear(:,jlev+1)) &
-               &  * transmittance(:,1,jlev) * inv_denom(:,1)
+          do jg = 1,ng
+            inv_denom(jg,1) = 1.0_jprb &
+                 &  / (1.0_jprb - total_albedo_clear(jg,jlev+1)*reflectance(jg,1,jlev))
+            total_albedo_clear(jg,jlev) = reflectance(jg,1,jlev) &
+                 &  + transmittance(jg,1,jlev) * transmittance(jg,1,jlev) &
+                 &  * total_albedo_clear(jg,jlev+1) * inv_denom(jg,1)
+            total_albedo_clear_direct(jg,jlev) = ref_dir(jg,1,jlev) &
+                 &  + (trans_dir_dir(jg,1,jlev)*total_albedo_clear_direct(jg,jlev+1) &
+                 &     +trans_dir_diff(jg,1,jlev)*total_albedo_clear(jg,jlev+1)) &
+                 &  * transmittance(jg,1,jlev) * inv_denom(jg,1)
+          end do
         end if
 
         if (is_clear_sky_layer(jlev)) then
-          inv_denom(:,1) = 1.0_jprb &
-               &  / (1.0_jprb - total_albedo(:,1,jlev+1)*reflectance(:,1,jlev))
-          total_albedo_below(:,1) = reflectance(:,1,jlev) &
-               &  + transmittance(:,1,jlev)  * transmittance(:,1,jlev) &
-               &  * total_albedo(:,1,jlev+1) * inv_denom(:,1)
-          total_albedo_below_direct(:,1) = ref_dir(:,1,jlev) &
-               &  + (trans_dir_dir(:,1,jlev)*total_albedo_direct(:,1,jlev+1) &
-               &     +trans_dir_diff(:,1,jlev)*total_albedo(:,1,jlev+1)) &
-               &  * transmittance(:,1,jlev) * inv_denom(:,1)
+          do jg = 1,ng
+            inv_denom(jg,1) = 1.0_jprb &
+                 &  / (1.0_jprb - total_albedo(jg,1,jlev+1)*reflectance(jg,1,jlev))
+            total_albedo_below(jg,1) = reflectance(jg,1,jlev) &
+                 &  + transmittance(jg,1,jlev)  * transmittance(jg,1,jlev) &
+                 &  * total_albedo(jg,1,jlev+1) * inv_denom(jg,1)
+            total_albedo_below_direct(jg,1) = ref_dir(jg,1,jlev) &
+                 &  + (trans_dir_dir(jg,1,jlev)*total_albedo_direct(jg,1,jlev+1) &
+                 &     +trans_dir_diff(jg,1,jlev)*total_albedo(jg,1,jlev+1)) &
+                 &  * transmittance(jg,1,jlev) * inv_denom(jg,1)
+          end do
         else
           inv_denom = 1.0_jprb / (1.0_jprb - total_albedo(:,:,jlev+1)*reflectance(:,:,jlev))
@@ -488,21 +493,26 @@
       do jlev = 1,nlev
         if (config%do_clear) then
-          flux_dn_clear = (transmittance(:,1,jlev)*flux_dn_clear + direct_dn_clear &
-               &  * (trans_dir_dir(:,1,jlev)*total_albedo_clear_direct(:,jlev+1)*reflectance(:,1,jlev) &
-               &     + trans_dir_diff(:,1,jlev) )) &
-               &  / (1.0_jprb - reflectance(:,1,jlev)*total_albedo_clear(:,jlev+1))
-          direct_dn_clear = trans_dir_dir(:,1,jlev)*direct_dn_clear
-          flux_up_clear = direct_dn_clear*total_albedo_clear_direct(:,jlev+1) &
-               &        +   flux_dn_clear*total_albedo_clear(:,jlev+1)
+          do jg = 1,ng
+            flux_dn_clear(jg) = (transmittance(jg,1,jlev)*flux_dn_clear(jg) + direct_dn_clear(jg) &
+               &  * (trans_dir_dir(jg,1,jlev)*total_albedo_clear_direct(jg,jlev+1)*reflectance(jg,1,jlev) &
+               &     + trans_dir_diff(jg,1,jlev) )) &
+               &  / (1.0_jprb - reflectance(jg,1,jlev)*total_albedo_clear(jg,jlev+1))
+            direct_dn_clear(jg) = trans_dir_dir(jg,1,jlev)*direct_dn_clear(jg)
+            flux_up_clear(jg) = direct_dn_clear(jg)*total_albedo_clear_direct(jg,jlev+1) &
+               &        +   flux_dn_clear(jg)*total_albedo_clear(jg,jlev+1)
+          end do
         end if
 
         if (is_clear_sky_layer(jlev)) then
-          flux_dn(:,1) = (transmittance(:,1,jlev)*flux_dn(:,1) + direct_dn(:,1) &
-               &  * (trans_dir_dir(:,1,jlev)*total_albedo_direct(:,1,jlev+1)*reflectance(:,1,jlev) &
-               &     + trans_dir_diff(:,1,jlev) )) &
-               &  / (1.0_jprb - reflectance(:,1,jlev)*total_albedo(:,1,jlev+1))
-          direct_dn(:,1) = trans_dir_dir(:,1,jlev)*direct_dn(:,1)
-          flux_up(:,1) = direct_dn(:,1)*total_albedo_direct(:,1,jlev+1) &
-               &  +        flux_dn(:,1)*total_albedo(:,1,jlev+1)
+          do jg = 1,ng
+            flux_dn(jg,1) = (transmittance(jg,1,jlev)*flux_dn(jg,1) + direct_dn(jg,1) &
+                 &  * (trans_dir_dir(jg,1,jlev)*total_albedo_direct(jg,1,jlev+1)*reflectance(jg,1,jlev) &
+                 &     + trans_dir_diff(jg,1,jlev) )) &
+                 &  / (1.0_jprb - reflectance(jg,1,jlev)*total_albedo(jg,1,jlev+1))
+            direct_dn(jg,1) = trans_dir_dir(jg,1,jlev)*direct_dn(jg,1)
+            flux_up(jg,1) = direct_dn(jg,1)*total_albedo_direct(jg,1,jlev+1) &
+                 &  +        flux_dn(jg,1)*total_albedo(jg,1,jlev+1)
+          end do
+
           flux_dn(:,2:)  = 0.0_jprb
           flux_up(:,2:)  = 0.0_jprb
